Subject: Re: RFC: stmmac RSS support

From: Qingfang Deng <[email-masked]>
Date: Mon, 9 Feb 2026 09:35:25 +0800

On Sat, 7 Feb 2026 17:36:06 +0000, Russell King (Oracle) wrote:
> Hi,
> 
> While looking at the possibilities of minimising the memory that
> struct plat_stmmacenet_data consumes (880 bytes presently on
> aarch64), I came across the RSS feature in stmmac.
> 
> In commit 76067459c686 ("net: stmmac: Implement RSS and enable it in
> XGMAC core"), support was added for RSS to the core stmmac driver for
> the dwxgmac2 core. I can only find socfpga and tegra as the two
> platform glues that use the dwxgmac2 core.
> 
> RSS support is only enabled when both the core supports it, and the
> platform glue sets priv->plat->rss_en.
> 
> However, the stmmac-related results of grepping for this member do not
> show any platform glues which set this flag:
> 
> $ git grep '\<rss_en\>'
> Documentation/networking/device_drivers/ethernet/stmicro/stmmac.rst:        int rss_en;
> drivers/net/ethernet/stmicro/stmmac/stmmac_main.c:      if (!priv->dma_cap.rssen || !priv->plat->rss_en) {
> drivers/net/ethernet/stmicro/stmmac/stmmac_main.c:      if (priv->dma_cap.rssen && priv->plat->rss_en)
> 
> So, as no one has decided to enable this feature during the intervening
> six years, is there any benefit to having this code in the mainline
> kernel, or should this feature be dropped?
> 
> If a user appears, the code will remain in git history and could be
> restored.
> 
> Thoughts?

As someone who has worked on both DWC GMAC and DWC XGMAC, I think the
whole XGMAC code needs to be uncoupled from the stmmac driver. They're
completely different IP cores.

> 
> -- 
> RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
> FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!
>